#ifndef EL__DOCUMENT_DOM_ECMASCRIPT_SPIDERMONKEY_PROPS_H
#define EL__DOCUMENT_DOM_ECMASCRIPT_SPIDERMONKEY_PROPS_H

#define PROP_BEGIN -120

enum DOMException_enum {
	JSP_DOM_EXCEPTION_CODE = PROP_BEGIN
};

enum DOMStringList_enum {
	JSP_DOM_STRING_LIST_LENGTH = PROP_BEGIN
};

enum NameList_enum {
	JSP_NAME_LIST_LENGTH = PROP_BEGIN
};

enum DOMImplementationList_enum {
	JSP_DOM_IMPLEMENTATION_LIST_LENGTH = PROP_BEGIN
};

enum Node_enum {
	JSP_NODE_NODE_NAME = PROP_BEGIN,
	JSP_NODE_NODE_VALUE,
	JSP_NODE_NODE_TYPE,
	JSP_NODE_PARENT_NODE,
	JSP_NODE_CHILD_NODES,
	JSP_NODE_FIRST_CHILD,
	JSP_NODE_LAST_CHILD,
	JSP_NODE_PREVIOUS_SIBLING,
	JSP_NODE_NEXT_SIBLING,
	JSP_NODE_ATTRIBUTES,
	JSP_NODE_OWNER_DOCUMENT,
	JSP_NODE_NAMESPACE_URI,
	JSP_NODE_PREFIX,
	JSP_NODE_LOCAL_NAME,
	JSP_NODE_BASE_URI,
	JSP_NODE_TEXT_CONTENT /* must be the last */
};

enum NodeList_enum {
	JSP_NODE_LIST_LENGTH = PROP_BEGIN
};

enum NamedNodeMap_enum {
	JSP_NAMED_NODE_MAP_LENGTH = PROP_BEGIN
};

enum CharacterData_enum {
	JSP_CHARACTER_DATA_DATA = JSP_NODE_TEXT_CONTENT + 1,
	JSP_CHARACTER_DATA_LENGTH /* must be the last */
};

enum Attr_enum {
	JSP_ATTR_NAME = JSP_NODE_TEXT_CONTENT + 1,
	JSP_ATTR_SPECIFIED,
	JSP_ATTR_VALUE,
	JSP_ATTR_OWNER_ELEMENT,
	JSP_ATTR_SCHEMA_TYPE_INFO,
	JSP_ATTR_IS_ID
};

enum Element_enum {
	JSP_ELEMENT_TAG_NAME = JSP_NODE_TEXT_CONTENT + 1,
	JSP_ELEMENT_SCHEMA_TYPE_INFO /* must be the last */
};

enum Text_enum {
	JSP_TEXT_IS_ELEMENT_CONTENT_WHITESPACE = JSP_CHARACTER_DATA_LENGTH + 1,
	JSP_TEXT_WHOLE_TEXT
};

enum TypeInfo_enum {
	JSP_TYPE_INFO_TYPE_NAME = PROP_BEGIN,
	JSP_TYPE_INFO_TYPE_NAMESPACE
};

enum DOMError_enum {
	JSP_DOM_ERROR_SEVERITY = PROP_BEGIN,
	JSP_DOM_ERROR_MESSAGE,
	JSP_DOM_ERROR_TYPE,
	JSP_DOM_ERROR_RELATED_EXCEPTION,
	JSP_DOM_ERROR_RELATED_DATA,
	JSP_DOM_ERROR_LOCATION
};

enum DOMLocator_enum {
	JSP_DOM_LOCATOR_LINE_NUMBER = PROP_BEGIN,
	JSP_DOM_LOCATOR_COLUMN_NUMBER,
	JSP_DOM_LOCATOR_BYTE_OFFSET,
	JSP_DOM_LOCATOR_UTF16_OFFSET,
	JSP_DOM_LOCATOR_RELATED_NODE,
	JSP_DOM_LOCATOR_URI
};

enum DOMConfiguration_enum {
	JSP_DOM_CONFIGURATION_PARAMETER_NAMES = PROP_BEGIN
};

enum DocumentType_enum {
	JSP_DOCUMENT_TYPE_NAME = JSP_NODE_TEXT_CONTENT + 1,
	JSP_DOCUMENT_TYPE_ENTITIES,
	JSP_DOCUMENT_TYPE_NOTATIONS,
	JSP_DOCUMENT_TYPE_PUBLIC_ID,
	JSP_DOCUMENT_TYPE_SYSTEM_ID,
	JSP_DOCUMENT_TYPE_INTERNAL_SUBSET
};

enum Notation_enum {
	JSP_NOTATION_PUBLIC_ID = JSP_NODE_TEXT_CONTENT + 1,
	JSP_NOTATION_SYSTEM_ID
};

enum Entity_enum {
	JSP_ENTITY_PUBLIC_ID = JSP_NODE_TEXT_CONTENT + 1,
	JSP_ENTITY_SYSTEM_ID,
	JSP_ENTITY_NOTATION_NAME,
	JSP_ENTITY_INPUT_ENCODING,
	JSP_ENTITY_XML_ENCODING,
	JSP_ENTITY_XML_VERSION
};

enum ProcessingInstruction_enum {
	JSP_PROCESSING_INSTRUCTION_TARGET = JSP_NODE_TEXT_CONTENT + 1,
	JSP_PROCESSING_INSTRUCTION_DATA
};

enum Document_enum {
	JSP_DOCUMENT_DOCTYPE = JSP_NODE_TEXT_CONTENT + 1,
	JSP_DOCUMENT_IMPLEMENTATION,
	JSP_DOCUMENT_DOCUMENT_ELEMENT,
	JSP_DOCUMENT_INPUT_ENCODING,
	JSP_DOCUMENT_XML_ENCODING,
	JSP_DOCUMENT_XML_STANDALONE,
	JSP_DOCUMENT_XML_VERSION,
	JSP_DOCUMENT_STRICT_ERROR_CHECKING,
	JSP_DOCUMENT_DOCUMENT_URI,
	JSP_DOCUMENT_DOM_CONFIG /* must be the last */
};

enum HTMLCollection_enum {
	JSP_HTML_COLLECTION_LENGTH = PROP_BEGIN
};

enum HTMLOptionsCollection_enum {
	JSP_HTML_OPTIONS_COLLECTION_LENGTH = PROP_BEGIN
};

enum HTMLDocument_enum {
	JSP_HTML_DOCUMENT_TITLE = JSP_DOCUMENT_DOM_CONFIG + 1,
	JSP_HTML_DOCUMENT_REFERER,
	JSP_HTML_DOCUMENT_DOMAIN,
	JSP_HTML_DOCUMENT_URL,
	JSP_HTML_DOCUMENT_BODY,
	JSP_HTML_DOCUMENT_IMAGES,
	JSP_HTML_DOCUMENT_APPLETS,
	JSP_HTML_DOCUMENT_LINKS,
	JSP_HTML_DOCUMENT_FORMS,
	JSP_HTML_DOCUMENT_ANCHORS,
	JSP_HTML_DOCUMENT_COOKIE
};

enum HTMLElement_enum {
	JSP_HTML_ELEMENT_ID = JSP_ELEMENT_SCHEMA_TYPE_INFO + 1,
	JSP_HTML_ELEMENT_TITLE,
	JSP_HTML_ELEMENT_LANG,
	JSP_HTML_ELEMENT_DIR,
	JSP_HTML_ELEMENT_CLASS_NAME /* must be the last */
};

enum HTMLHtmlElement_enum {
	JSP_HTML_HTML_ELEMENT_VERSION = JSP_HTML_ELEMENT_CLASS_NAME + 1
};

enum HTMLHeadElement_enum {
	JSP_HTML_HEAD_ELEMENT_PROFILE = JSP_HTML_ELEMENT_CLASS_NAME + 1
};

enum HTMLLinkElement_enum {
	JSP_HTML_LINK_ELEMENT_DISABLED = JSP_HTML_ELEMENT_CLASS_NAME + 1,
	JSP_HTML_LINK_ELEMENT_CHARSET,
	JSP_HTML_LINK_ELEMENT_HREF,
	JSP_HTML_LINK_ELEMENT_HREFLANG,
	JSP_HTML_LINK_ELEMENT_MEDIA,
	JSP_HTML_LINK_ELEMENT_REL,
	JSP_HTML_LINK_ELEMENT_REV,
	JSP_HTML_LINK_ELEMENT_TARGET,
	JSP_HTML_LINK_ELEMENT_TYPE
};

enum HTMLTitleELement_enum {
	JSP_HTML_TITLE_ELEMENT_TEXT = JSP_HTML_ELEMENT_CLASS_NAME + 1
};

enum HTMLMetaElement_enum {
	JSP_HTML_META_ELEMENT_CONTENT = JSP_HTML_ELEMENT_CLASS_NAME + 1,
	JSP_HTML_META_ELEMENT_HTTP_EQUIV,
	JSP_HTML_META_ELEMENT_NAME,
	JSP_HTML_META_ELEMENT_SCHEME
};

enum HTMLBaseElement_enum {
	JSP_HTML_BASE_ELEMENT_HREF = JSP_HTML_ELEMENT_CLASS_NAME + 1,
	JSP_HTML_BASE_ELEMENT_TARGET
};

enum HTMLIsIndexElement_enum {
	JSP_HTML_IS_INDEX_ELEMENT_FORM = JSP_HTML_ELEMENT_CLASS_NAME + 1,
	JSP_HTML_IS_INDEX_ELEMENT_PROMPT
  };

enum HTMLStyleElement_enum {
	JSP_HTML_STYLE_ELEMENT_DISABLED = JSP_HTML_ELEMENT_CLASS_NAME + 1,
	JSP_HTML_STYLE_ELEMENT_MEDIA,
	JSP_HTML_STYLE_ELEMENT_TYPE
};

enum HTMLBodyElement_enum {
	JSP_HTML_BODY_ELEMENT_ALINK = JSP_HTML_ELEMENT_CLASS_NAME + 1,
	JSP_HTML_BODY_ELEMENT_BACKGROUND,
	JSP_HTML_BODY_ELEMENT_BGCOLOR,
	JSP_HTML_BODY_ELEMENT_LINK,
	JSP_HTML_BODY_ELEMENT_TEXT,
	JSP_HTML_BODY_ELEMENT_VLINK
};

enum HTMLFormElement_enum {
	JSP_HTML_FORM_ELEMENT_ELEMENTS = JSP_HTML_ELEMENT_CLASS_NAME + 1,
	JSP_HTML_FORM_ELEMENT_LENGTH,
	JSP_HTML_FORM_ELEMENT_NAME,
	JSP_HTML_FORM_ELEMENT_ACCEPT_CHARSET,
	JSP_HTML_FORM_ELEMENT_ACTION,
	JSP_HTML_FORM_ELEMENT_ENCTYPE,
	JSP_HTML_FORM_ELEMENT_METHOD,
	JSP_HTML_FORM_ELEMENT_TARGET
};

enum HTMLSelectElement_enum {
	JSP_HTML_SELECT_ELEMENT_TYPE = JSP_HTML_ELEMENT_CLASS_NAME + 1,
	JSP_HTML_SELECT_ELEMENT_SELECTED_INDEX,
	JSP_HTML_SELECT_ELEMENT_VALUE,
	JSP_HTML_SELECT_ELEMENT_LENGTH,
	JSP_HTML_SELECT_ELEMENT_FORM,
	JSP_HTML_SELECT_ELEMENT_OPTIONS,
	JSP_HTML_SELECT_ELEMENT_DISABLED,
	JSP_HTML_SELECT_ELEMENT_MULTIPLE,
	JSP_HTML_SELECT_ELEMENT_NAME,
	JSP_HTML_SELECT_ELEMENT_SIZE,
	JSP_HTML_SELECT_ELEMENT_TAB_INDEX
};

enum HTMLOptGroupElement_enum {
	JSP_HTML_OPT_GROUP_ELEMENT_DISABLED = JSP_HTML_ELEMENT_CLASS_NAME + 1,
	JSP_HTML_OPT_GROUP_ELEMENT_LABEL
};

enum HTMLOptionElement_enum {
	JSP_HTML_OPTION_ELEMENT_FORM = JSP_HTML_ELEMENT_CLASS_NAME + 1,
	JSP_HTML_OPTION_ELEMENT_DEFAULT_SELECTED,
	JSP_HTML_OPTION_ELEMENT_TEXT,
	JSP_HTML_OPTION_ELEMENT_INDEX,
	JSP_HTML_OPTION_ELEMENT_DISABLED,
	JSP_HTML_OPTION_ELEMENT_LABEL,
	JSP_HTML_OPTION_ELEMENT_SELECTED,
	JSP_HTML_OPTION_ELEMENT_VALUE
};

enum HTMLInputElement_enum {
	JSP_HTML_INPUT_ELEMENT_DEFAULT_VALUE = JSP_HTML_ELEMENT_CLASS_NAME + 1,
	JSP_HTML_INPUT_ELEMENT_DEFAULT_CHECKED,
	JSP_HTML_INPUT_ELEMENT_FORM,
	JSP_HTML_INPUT_ELEMENT_ACCEPT,
	JSP_HTML_INPUT_ELEMENT_ACCESS_KEY,
	JSP_HTML_INPUT_ELEMENT_ALIGN,
	JSP_HTML_INPUT_ELEMENT_ALT,
	JSP_HTML_INPUT_ELEMENT_CHECKED,
	JSP_HTML_INPUT_ELEMENT_DISABLED,
	JSP_HTML_INPUT_ELEMENT_MAX_LENGTH,
	JSP_HTML_INPUT_ELEMENT_NAME,
	JSP_HTML_INPUT_ELEMENT_READ_ONLY,
	JSP_HTML_INPUT_ELEMENT_SIZE,
	JSP_HTML_INPUT_ELEMENT_SRC,
	JSP_HTML_INPUT_ELEMENT_TAB_INDEX,
	JSP_HTML_INPUT_ELEMENT_TYPE,
	JSP_HTML_INPUT_ELEMENT_USE_MAP,
	JSP_HTML_INPUT_ELEMENT_VALUE
};

enum HTMLTextAreaElement_enum {
	JSP_HTML_TEXT_AREA_ELEMENT_DEFAULT_VALUE = JSP_HTML_ELEMENT_CLASS_NAME + 1,
	JSP_HTML_TEXT_AREA_ELEMENT_FORM,
	JSP_HTML_TEXT_AREA_ELEMENT_ACCESS_KEY,
	JSP_HTML_TEXT_AREA_ELEMENT_COLS,
	JSP_HTML_TEXT_AREA_ELEMENT_DISABLED,
	JSP_HTML_TEXT_AREA_ELEMENT_NAME,
	JSP_HTML_TEXT_AREA_ELEMENT_READ_ONLY,
	JSP_HTML_TEXT_AREA_ELEMENT_ROWS,
	JSP_HTML_TEXT_AREA_ELEMENT_TAB_INDEX,
	JSP_HTML_TEXT_AREA_ELEMENT_TYPE,
	JSP_HTML_TEXT_AREA_ELEMENT_VALUE
};

enum HTMLButtonElement_enum {
	JSP_HTML_BUTTON_ELEMENT_FORM = JSP_HTML_ELEMENT_CLASS_NAME + 1,
	JSP_HTML_BUTTON_ELEMENT_ACCESS_KEY,
	JSP_HTML_BUTTON_ELEMENT_DISABLED,
	JSP_HTML_BUTTON_ELEMENT_NAME,
	JSP_HTML_BUTTON_ELEMENT_TAB_INDEX,
	JSP_HTML_BUTTON_ELEMENT_TYPE,
	JSP_HTML_BUTTON_ELEMENT_VALUE
};

enum HTMLLabelElement_enum {
	JSP_HTML_LABEL_ELEMENT_FORM = JSP_HTML_ELEMENT_CLASS_NAME + 1,
	JSP_HTML_LABEL_ELEMENT_ACCESS_KEY,
	JSP_HTML_LABEL_ELEMENT_HTML_FOR
};

enum HTMLFieldSetElement_enum {
	JSP_HTML_FIELD_SET_ELEMENT_FORM = JSP_HTML_ELEMENT_CLASS_NAME + 1
};

enum HTMLLegendElement_enum {
	JSP_HTML_LEGEND_ELEMENT_FORM = JSP_HTML_ELEMENT_CLASS_NAME + 1,
	JSP_HTML_LEGEND_ELEMENT_ACCESS_KEY,
	JSP_HTML_LEGEND_ELEMENT_ALIGN
};

enum HTMLUListElement_enum {
	JSP_HTML_ULIST_ELEMENT_COMPACT = JSP_HTML_ELEMENT_CLASS_NAME + 1,
	JSP_HTML_ULIST_ELEMENT_TYPE
};

enum HTMLOListElement_enum {
	JSP_HTML_OLIST_ELEMENT_COMPACT = JSP_HTML_ELEMENT_CLASS_NAME + 1,
	JSP_HTML_OLIST_ELEMENT_START,
	JSP_HTML_OLIST_ELEMENT_TYPE
};

enum HTMLDListElement_enum {
	JSP_HTML_DLIST_ELEMENT_COMPACT = JSP_HTML_ELEMENT_CLASS_NAME + 1
};

enum HTMLDirectoryElement_enum {
	JSP_HTML_DIRECTORY_ELEMENT_COMPACT = JSP_HTML_ELEMENT_CLASS_NAME + 1,
};

enum HTMLMenuElement_enum {
	JSP_HTML_MENU_ELEMENT_COMPACT = JSP_HTML_ELEMENT_CLASS_NAME + 1,
};

enum HTMLLIElement_enum {
	JSP_HTML_LI_ELEMENT_TYPE = JSP_HTML_ELEMENT_CLASS_NAME + 1,
	JSP_HTML_LI_ELEMENT_VALUE
};

enum HTMLDivElement_enum {
	JSP_HTML_DIV_ELEMENT_ALIGN = JSP_HTML_ELEMENT_CLASS_NAME + 1
};

enum HTMLParagraphElement_enum {
	JSP_HTML_PARAGRAPH_ELEMENT_ALIGN = JSP_HTML_ELEMENT_CLASS_NAME + 1
};

enum HTMLHeadingElement_enum {
	JSP_HTML_HEADING_ELEMENT_ALIGN = JSP_HTML_ELEMENT_CLASS_NAME + 1
};

enum HTMLQuoteElement_enum {
	JSP_HTML_QUOTE_ELEMENT_CITE = JSP_HTML_ELEMENT_CLASS_NAME + 1
};

enum HTMLPreElement_enum {
	JSP_HTML_PRE_ELEMENT_WIDTH = JSP_HTML_ELEMENT_CLASS_NAME + 1
};

enum HTMLBRElement_enum {
	JSP_HTML_BR_ELEMENT_CLEAR = JSP_HTML_ELEMENT_CLASS_NAME + 1
};

enum HTMLBaseFontElement_enum {
	JSP_HTML_BASE_FONT_ELEMENT_COLOR = JSP_HTML_ELEMENT_CLASS_NAME + 1,
	JSP_HTML_BASE_FONT_ELEMENT_FACE,
	JSP_HTML_BASE_FONT_ELEMENT_SIZE
};

enum HTMLFontElement_enum {
	JSP_HTML_FONT_ELEMENT_COLOR = JSP_HTML_ELEMENT_CLASS_NAME + 1,
	JSP_HTML_FONT_ELEMENT_FACE,
	JSP_HTML_FONT_ELEMENT_SIZE
};

enum HTMLHRElement_enum {
	JSP_HTML_HR_ELEMENT_ALIGN = JSP_HTML_ELEMENT_CLASS_NAME + 1,
	JSP_HTML_HR_ELEMENT_NO_SHADE,
	JSP_HTML_HR_ELEMENT_SIZE,
	JSP_HTML_HR_ELEMENT_WIDTH
};

enum HTMLModElement_enum {
	JSP_HTML_MOD_ELEMENT_CITE = JSP_HTML_ELEMENT_CLASS_NAME + 1,
	JSP_HTML_MOD_ELEMENT_DATE_TIME
};

enum HTMLAnchorElement_enum {
	JSP_HTML_ANCHOR_ELEMENT_ACCESS_KEY = JSP_HTML_ELEMENT_CLASS_NAME + 1,
	JSP_HTML_ANCHOR_ELEMENT_CHARSET,
	JSP_HTML_ANCHOR_ELEMENT_COORDS,
	JSP_HTML_ANCHOR_ELEMENT_HREF,
	JSP_HTML_ANCHOR_ELEMENT_HREFLANG,
	JSP_HTML_ANCHOR_ELEMENT_NAME,
	JSP_HTML_ANCHOR_ELEMENT_REL,
	JSP_HTML_ANCHOR_ELEMENT_REV,
	JSP_HTML_ANCHOR_ELEMENT_SHAPE,
	JSP_HTML_ANCHOR_ELEMENT_TAB_INDEX,
	JSP_HTML_ANCHOR_ELEMENT_TARGET,
	JSP_HTML_ANCHOR_ELEMENT_TYPE
};

enum HTMLImageElement_enum {
	JSP_HTML_IMAGE_ELEMENT_NAME = JSP_HTML_ELEMENT_CLASS_NAME + 1,
	JSP_HTML_IMAGE_ELEMENT_ALIGN,
	JSP_HTML_IMAGE_ELEMENT_ALT,
	JSP_HTML_IMAGE_ELEMENT_BORDER,
	JSP_HTML_IMAGE_ELEMENT_HEIGHT,
	JSP_HTML_IMAGE_ELEMENT_HSPACE,
	JSP_HTML_IMAGE_ELEMENT_IS_MAP,
	JSP_HTML_IMAGE_ELEMENT_LONG_DESC,
	JSP_HTML_IMAGE_ELEMENT_SRC,
	JSP_HTML_IMAGE_ELEMENT_USE_MAP,
	JSP_HTML_IMAGE_ELEMENT_VSPACE,
	JSP_HTML_IMAGE_ELEMENT_WIDTH
};

enum HTMLObjectElement {
	JSP_HTML_OBJECT_ELEMENT_FORM = JSP_HTML_ELEMENT_CLASS_NAME + 1,
	JSP_HTML_OBJECT_ELEMENT_CODE,
	JSP_HTML_OBJECT_ELEMENT_ALIGN,
	JSP_HTML_OBJECT_ELEMENT_ARCHIVE,
	JSP_HTML_OBJECT_ELEMENT_BORDER,
	JSP_HTML_OBJECT_ELEMENT_CODE_BASE,
	JSP_HTML_OBJECT_ELEMENT_CODE_TYPE,
	JSP_HTML_OBJECT_ELEMENT_DATA,
	JSP_HTML_OBJECT_ELEMENT_DECLARE,
	JSP_HTML_OBJECT_ELEMENT_HEIGHT,
	JSP_HTML_OBJECT_ELEMENT_HSPACE,
	JSP_HTML_OBJECT_ELEMENT_NAME,
	JSP_HTML_OBJECT_ELEMENT_STANDBY,
	JSP_HTML_OBJECT_ELEMENT_TAB_INDEX,
	JSP_HTML_OBJECT_ELEMENT_TYPE,
	JSP_HTML_OBJECT_ELEMENT_USE_MAP,
	JSP_HTML_OBJECT_ELEMENT_VSPACE,
	JSP_HTML_OBJECT_ELEMENT_WIDTH,
	JSP_HTML_OBJECT_ELEMENT_CONTENT_DOCUMENT
};

enum HTMLParamElement_enum {
	JSP_HTML_PARAM_ELEMENT_NAME = JSP_HTML_ELEMENT_CLASS_NAME + 1,
	JSP_HTML_PARAM_ELEMENT_TYPE,
	JSP_HTML_PARAM_ELEMENT_VALUE,
	JSP_HTML_PARAM_ELEMENT_VALUE_TYPE
};

enum HTMLAppletElement_enum {
	JSP_HTML_APPLET_ELEMENT_ALIGN = JSP_HTML_ELEMENT_CLASS_NAME + 1,
	JSP_HTML_APPLET_ELEMENT_ALT,
	JSP_HTML_APPLET_ELEMENT_ARCHIVE,
	JSP_HTML_APPLET_ELEMENT_CODE,
	JSP_HTML_APPLET_ELEMENT_CODE_BASE,
	JSP_HTML_APPLET_ELEMENT_HEIGHT,
	JSP_HTML_APPLET_ELEMENT_HSPACE,
	JSP_HTML_APPLET_ELEMENT_NAME,
	JSP_HTML_APPLET_ELEMENT_OBJECT,
	JSP_HTML_APPLET_ELEMENT_VSPACE,
	JSP_HTML_APPLET_ELEMENT_WIDTH
};

enum HTMLMapElement_enum {
	JSP_HTML_MAP_ELEMENT_AREAS = JSP_HTML_ELEMENT_CLASS_NAME + 1,
	JSP_HTML_MAP_ELEMENT_NAME
};

enum HTMLAreaElement_enum {
	JSP_HTML_AREA_ELEMENT_ACCESS_KEY = JSP_HTML_ELEMENT_CLASS_NAME + 1,
	JSP_HTML_AREA_ELEMENT_ALT,
	JSP_HTML_AREA_ELEMENT_COORDS,
	JSP_HTML_AREA_ELEMENT_HREF,
	JSP_HTML_AREA_ELEMENT_NO_HREF,
	JSP_HTML_AREA_ELEMENT_SHAPE,
	JSP_HTML_AREA_ELEMENT_TAB_INDEX,
	JSP_HTML_AREA_ELEMENT_TARGET
};

enum HTMLScriptElement_enum {
	JSP_HTML_SCRIPT_ELEMENT_TEXT = JSP_HTML_ELEMENT_CLASS_NAME + 1,
	JSP_HTML_SCRIPT_ELEMENT_HTML_FOR,
	JSP_HTML_SCRIPT_ELEMENT_EVENT,
	JSP_HTML_SCRIPT_ELEMENT_CHARSET,
	JSP_HTML_SCRIPT_ELEMENT_DEFER,
	JSP_HTML_SCRIPT_ELEMENT_SRC,
	JSP_HTML_SCRIPT_ELEMENT_TYPE
};

enum HTMLTableElement_enum {
	JSP_HTML_TABLE_ELEMENT_CAPTION = JSP_HTML_ELEMENT_CLASS_NAME + 1,
	JSP_HTML_TABLE_ELEMENT_THEAD,
	JSP_HTML_TABLE_ELEMENT_TFOOT,
	JSP_HTML_TABLE_ELEMENT_ROWS,
	JSP_HTML_TABLE_ELEMENT_TBODIES,
	JSP_HTML_TABLE_ELEMENT_ALIGN,
	JSP_HTML_TABLE_ELEMENT_BGCOLOR,
	JSP_HTML_TABLE_ELEMENT_BORDER,
	JSP_HTML_TABLE_ELEMENT_CELL_PADDING,
	JSP_HTML_TABLE_ELEMENT_CELL_SPACING,
	JSP_HTML_TABLE_ELEMENT_FRAME,
	JSP_HTML_TABLE_ELEMENT_RULES,
	JSP_HTML_TABLE_ELEMENT_SUMMARY,
	JSP_HTML_TABLE_ELEMENT_WIDTH
};

enum HTMLTableCaptionElement_enum {
	JSP_HTML_TABLE_CAPTION_ELEMENT_ALIGN = JSP_HTML_ELEMENT_CLASS_NAME + 1
};

enum HTMLTableColElement_enum {
	JSP_HTML_TABLE_COL_ELEMENT_ALIGN = JSP_HTML_ELEMENT_CLASS_NAME + 1,
	JSP_HTML_TABLE_COL_ELEMENT_CH,
	JSP_HTML_TABLE_COL_ELEMENT_CH_OFF,
	JSP_HTML_TABLE_COL_ELEMENT_SPAN,
	JSP_HTML_TABLE_COL_ELEMENT_VALIGN,
	JSP_HTML_TABLE_COL_ELEMENT_WIDTH
};

enum HTMLTableSectionElement_enum {
	JSP_HTML_TABLE_SECTION_ELEMENT_ALIGN = JSP_HTML_ELEMENT_CLASS_NAME + 1,
	JSP_HTML_TABLE_SECTION_ELEMENT_CH,
	JSP_HTML_TABLE_SECTION_ELEMENT_CH_OFF,
	JSP_HTML_TABLE_SECTION_ELEMENT_VALIGN,
	JSP_HTML_TABLE_SECTION_ELEMENT_ROWS
};

enum HTMLTableRowElement_enum {
	JSP_HTML_TABLE_ROW_ELEMENT_ROW_INDEX = JSP_HTML_ELEMENT_CLASS_NAME + 1,
	JSP_HTML_TABLE_ROW_ELEMENT_SECTION_ROW_INDEX,
	JSP_HTML_TABLE_ROW_ELEMENT_CELLS,
	JSP_HTML_TABLE_ROW_ELEMENT_ALIGN,
	JSP_HTML_TABLE_ROW_ELEMENT_BGCOLOR,
	JSP_HTML_TABLE_ROW_ELEMENT_CH,
	JSP_HTML_TABLE_ROW_ELEMENT_CH_OFF,
	JSP_HTML_TABLE_ROW_ELEMENT_VALIGN
};

enum HTMLTableCellElement_enum {
	JSP_HTML_TABLE_CELL_ELEMENT_CELL_INDEX = JSP_HTML_ELEMENT_CLASS_NAME + 1,
	JSP_HTML_TABLE_CELL_ELEMENT_ABBR,
	JSP_HTML_TABLE_CELL_ELEMENT_ALIGN,
	JSP_HTML_TABLE_CELL_ELEMENT_AXIS,
	JSP_HTML_TABLE_CELL_ELEMENT_BGCOLOR,
	JSP_HTML_TABLE_CELL_ELEMENT_CH,
	JSP_HTML_TABLE_CELL_ELEMENT_CH_OFF,
	JSP_HTML_TABLE_CELL_ELEMENT_COL_SPAN,
	JSP_HTML_TABLE_CELL_ELEMENT_HEADERS,
	JSP_HTML_TABLE_CELL_ELEMENT_HEIGHT,
	JSP_HTML_TABLE_CELL_ELEMENT_NO_WRAP,
	JSP_HTML_TABLE_CELL_ELEMENT_ROW_SPAN,
	JSP_HTML_TABLE_CELL_ELEMENT_SCOPE,
	JSP_HTML_TABLE_CELL_ELEMENT_VALIGN,
	JSP_HTML_TABLE_CELL_ELEMENT_WIDTH
};

enum HTMLFrameSetElement_enum {
	JSP_HTML_FRAME_SET_ELEMENT_COLS = JSP_HTML_ELEMENT_CLASS_NAME + 1,
	JSP_HTML_FRAME_SET_ELEMENT_ROWS
};

enum HTMLFrameElement_enum {
	JSP_HTML_FRAME_ELEMENT_FRAME_BORDER = JSP_HTML_ELEMENT_CLASS_NAME + 1,
	JSP_HTML_FRAME_ELEMENT_LONG_DESC,
	JSP_HTML_FRAME_ELEMENT_MARGIN_HEIGHT,
	JSP_HTML_FRAME_ELEMENT_MARGIN_WIDTH,
	JSP_HTML_FRAME_ELEMENT_NAME,
	JSP_HTML_FRAME_ELEMENT_NO_RESIZE,
	JSP_HTML_FRAME_ELEMENT_SCROLLING,
	JSP_HTML_FRAME_ELEMENT_SRC,
	JSP_HTML_FRAME_ELEMENT_CONTENT_DOCUMENT
};

enum HTMLIFrameElement_enum {
	JSP_HTML_IFRAME_ELEMENT_ALIGN = JSP_HTML_ELEMENT_CLASS_NAME + 1,
	JSP_HTML_IFRAME_ELEMENT_FRAME_BORDER,
	JSP_HTML_IFRAME_ELEMENT_HEIGHT,
	JSP_HTML_IFRAME_ELEMENT_LONG_DESC,
	JSP_HTML_IFRAME_ELEMENT_MARGIN_HEIGHT,
	JSP_HTML_IFRAME_ELEMENT_MARGIN_WIDTH,
	JSP_HTML_IFRAME_ELEMENT_NAME,
	JSP_HTML_IFRAME_ELEMENT_SCROLLING,
	JSP_HTML_IFRAME_ELEMENT_SRC,
	JSP_HTML_IFRAME_ELEMENT_WIDTH,
	JSP_HTML_IFRAME_ELEMENT_CONTENT_DOCUMENT
};

#endif
